Index: chameleon/atari800core.qsf
===================================================================
--- chameleon/atari800core.qsf	(revision 174)
+++ chameleon/atari800core.qsf	(revision 175)
@@ -205,8 +205,9 @@
 set_global_assignment -name VHDL_FILE gen_usart.vhd
 set_global_assignment -name VHDL_FILE chameleon_usb.vhd
 set_global_assignment -name VHDL_FILE atari800core_chameleon.vhd
-set_global_assignment -name QIP_FILE pll_pal.qip
-set_global_assignment -name QIP_FILE pll_ntsc.qip
+set_global_assignment -name QIP_FILE pll_pal_post.qip
+set_global_assignment -name QIP_FILE pll_ntsc_post.qip
+set_global_assignment -name QIP_FILE pll_pre.qip
 set_global_assignment -name RESERVE_DATA0_AFTER_CONFIGURATION "USE AS REGULAR IO"
 set_global_assignment -name RESERVE_DATA1_AFTER_CONFIGURATION "USE AS REGULAR IO"
 set_global_assignment -name RESERVE_FLASH_NCE_AFTER_CONFIGURATION "USE AS REGULAR IO"
Index: chameleon/atari800core_chameleon.vhd
===================================================================
--- chameleon/atari800core_chameleon.vhd	(revision 174)
+++ chameleon/atari800core_chameleon.vhd	(revision 175)
@@ -103,6 +103,8 @@
   signal CLK : std_logic;
   signal CLK_SDRAM : std_logic;
 
+  signal CLK_PLL1 : std_logic; -- cascaded to get better clock
+  signal PLL1_LOCKED : std_logic;
 
 -- SDRAM
   signal SDRAM_REQUEST : std_logic;
@@ -295,28 +297,34 @@
 --sd_ldqm <= '0';
 --sd_udqm <= '0';
 
--- simplest possible implementation
 -- pll
+chameleon_pll : entity work.pll_pre
+PORT MAP(inclk0 => clk8,
+		 c0 => CLK_PLL1,
+		 locked => PLL1_LOCKED);
+
 gen_ntsc_pll : if tv=0 generate
-chameleon_pll : entity work.pll_ntsc
+chameleon_pll2 : entity work.pll_ntsc_post
 	PORT MAP
 	(
-		inclk0 => clk8,
+		inclk0 => CLK_PLL1,
 		c0 => clk_sdram,
 		c1 => clk,
 		c2 => sd_clk,
+		areset => not(PLL1_LOCKED),
 		locked => pll_locked
 	);
 end generate;
 
 gen_pal_pll : if tv=1 generate
-chameleon_pll : entity work.pll_pal
+chameleon_pll2 : entity work.pll_pal_post
 	PORT MAP
 	(
-		inclk0 => clk8,
+		inclk0 => CLK_PLL1,
 		c0 => clk_sdram,
 		c1 => clk,
 		c2 => sd_clk,
+		areset => not(PLL1_LOCKED),
 		locked => pll_locked
 	);
 end generate;
Index: chameleon/pll_ntsc_post.cmp
===================================================================
--- chameleon/pll_ntsc_post.cmp	(nonexistent)
+++ chameleon/pll_ntsc_post.cmp	(revision 175)
@@ -0,0 +1,26 @@
+--Copyright (C) 1991-2013 Altera Corporation
+--Your use of Altera Corporation's design tools, logic functions 
+--and other software and tools, and its AMPP partner logic 
+--functions, and any output files from any of the foregoing 
+--(including device programming or simulation files), and any 
+--associated documentation or information are expressly subject 
+--to the terms and conditions of the Altera Program License 
+--Subscription Agreement, Altera MegaCore Function License 
+--Agreement, or other applicable license agreement, including, 
+--without limitation, that your use is for the sole purpose of 
+--programming logic devices manufactured by Altera and sold by 
+--Altera or its authorized distributors.  Please refer to the 
+--applicable agreement for further details.
+
+
+component pll_ntsc_post
+	PORT
+	(
+		areset		: IN STD_LOGIC  := '0';
+		inclk0		: IN STD_LOGIC  := '0';
+		c0		: OUT STD_LOGIC ;
+		c1		: OUT STD_LOGIC ;
+		c2		: OUT STD_LOGIC ;
+		locked		: OUT STD_LOGIC 
+	);
+end component;
Index: chameleon/pll_ntsc_post.ppf
===================================================================
--- chameleon/pll_ntsc_post.ppf	(nonexistent)
+++ chameleon/pll_ntsc_post.ppf	(revision 175)
@@ -0,0 +1,13 @@
+<?xml version="1.0" encoding="UTF-8" ?>
+<!DOCTYPE pinplan>
+<pinplan intended_family="Cyclone III" variation_name="pll_ntsc_post" megafunction_name="ALTPLL" specifies="all_ports">
+<global>
+<pin name="areset" direction="input" scope="external"  />
+<pin name="inclk0" direction="input" scope="external" source="clock"  />
+<pin name="c0" direction="output" scope="external" source="clock"  />
+<pin name="c1" direction="output" scope="external" source="clock"  />
+<pin name="c2" direction="output" scope="external" source="clock"  />
+<pin name="locked" direction="output" scope="external"  />
+
+</global>
+</pinplan>
Index: chameleon/pll_ntsc_post.qip
===================================================================
--- chameleon/pll_ntsc_post.qip	(nonexistent)
+++ chameleon/pll_ntsc_post.qip	(revision 175)
@@ -0,0 +1,5 @@
+set_global_assignment -name IP_TOOL_NAME "ALTPLL"
+set_global_assignment -name IP_TOOL_VERSION "13.0"
+set_global_assignment -name VHDL_FILE [file join $::quartus(qip_path) "pll_ntsc_post.vhd"]
+set_global_assignment -name MISC_FILE [file join $::quartus(qip_path) "pll_ntsc_post.cmp"]
+set_global_assignment -name MISC_FILE [file join $::quartus(qip_path) "pll_ntsc_post.ppf"]
Index: chameleon/pll_pal_post.cmp
===================================================================
--- chameleon/pll_pal_post.cmp	(nonexistent)
+++ chameleon/pll_pal_post.cmp	(revision 175)
@@ -0,0 +1,26 @@
+--Copyright (C) 1991-2013 Altera Corporation
+--Your use of Altera Corporation's design tools, logic functions 
+--and other software and tools, and its AMPP partner logic 
+--functions, and any output files from any of the foregoing 
+--(including device programming or simulation files), and any 
+--associated documentation or information are expressly subject 
+--to the terms and conditions of the Altera Program License 
+--Subscription Agreement, Altera MegaCore Function License 
+--Agreement, or other applicable license agreement, including, 
+--without limitation, that your use is for the sole purpose of 
+--programming logic devices manufactured by Altera and sold by 
+--Altera or its authorized distributors.  Please refer to the 
+--applicable agreement for further details.
+
+
+component pll_pal_post
+	PORT
+	(
+		areset		: IN STD_LOGIC  := '0';
+		inclk0		: IN STD_LOGIC  := '0';
+		c0		: OUT STD_LOGIC ;
+		c1		: OUT STD_LOGIC ;
+		c2		: OUT STD_LOGIC ;
+		locked		: OUT STD_LOGIC 
+	);
+end component;
Index: chameleon/pll_pal_post.ppf
===================================================================
--- chameleon/pll_pal_post.ppf	(nonexistent)
+++ chameleon/pll_pal_post.ppf	(revision 175)
@@ -0,0 +1,13 @@
+<?xml version="1.0" encoding="UTF-8" ?>
+<!DOCTYPE pinplan>
+<pinplan intended_family="Cyclone III" variation_name="pll_pal_post" megafunction_name="ALTPLL" specifies="all_ports">
+<global>
+<pin name="areset" direction="input" scope="external"  />
+<pin name="inclk0" direction="input" scope="external" source="clock"  />
+<pin name="c0" direction="output" scope="external" source="clock"  />
+<pin name="c1" direction="output" scope="external" source="clock"  />
+<pin name="c2" direction="output" scope="external" source="clock"  />
+<pin name="locked" direction="output" scope="external"  />
+
+</global>
+</pinplan>
Index: chameleon/pll_pal_post.qip
===================================================================
--- chameleon/pll_pal_post.qip	(nonexistent)
+++ chameleon/pll_pal_post.qip	(revision 175)
@@ -0,0 +1,5 @@
+set_global_assignment -name IP_TOOL_NAME "ALTPLL"
+set_global_assignment -name IP_TOOL_VERSION "13.0"
+set_global_assignment -name VHDL_FILE [file join $::quartus(qip_path) "pll_pal_post.vhd"]
+set_global_assignment -name MISC_FILE [file join $::quartus(qip_path) "pll_pal_post.cmp"]
+set_global_assignment -name MISC_FILE [file join $::quartus(qip_path) "pll_pal_post.ppf"]
Index: chameleon/pll_pre.cmp
===================================================================
--- chameleon/pll_pre.cmp	(nonexistent)
+++ chameleon/pll_pre.cmp	(revision 175)
@@ -0,0 +1,23 @@
+--Copyright (C) 1991-2013 Altera Corporation
+--Your use of Altera Corporation's design tools, logic functions 
+--and other software and tools, and its AMPP partner logic 
+--functions, and any output files from any of the foregoing 
+--(including device programming or simulation files), and any 
+--associated documentation or information are expressly subject 
+--to the terms and conditions of the Altera Program License 
+--Subscription Agreement, Altera MegaCore Function License 
+--Agreement, or other applicable license agreement, including, 
+--without limitation, that your use is for the sole purpose of 
+--programming logic devices manufactured by Altera and sold by 
+--Altera or its authorized distributors.  Please refer to the 
+--applicable agreement for further details.
+
+
+component pll_pre
+	PORT
+	(
+		inclk0		: IN STD_LOGIC  := '0';
+		c0		: OUT STD_LOGIC ;
+		locked		: OUT STD_LOGIC 
+	);
+end component;
Index: chameleon/pll_pre.ppf
===================================================================
--- chameleon/pll_pre.ppf	(nonexistent)
+++ chameleon/pll_pre.ppf	(revision 175)
@@ -0,0 +1,10 @@
+<?xml version="1.0" encoding="UTF-8" ?>
+<!DOCTYPE pinplan>
+<pinplan intended_family="Cyclone III" variation_name="pll_pre" megafunction_name="ALTPLL" specifies="all_ports">
+<global>
+<pin name="inclk0" direction="input" scope="external" source="clock"  />
+<pin name="c0" direction="output" scope="external" source="clock"  />
+<pin name="locked" direction="output" scope="external"  />
+
+</global>
+</pinplan>
Index: chameleon/pll_pre.qip
===================================================================
--- chameleon/pll_pre.qip	(nonexistent)
+++ chameleon/pll_pre.qip	(revision 175)
@@ -0,0 +1,5 @@
+set_global_assignment -name IP_TOOL_NAME "ALTPLL"
+set_global_assignment -name IP_TOOL_VERSION "13.0"
+set_global_assignment -name VHDL_FILE [file join $::quartus(qip_path) "pll_pre.vhd"]
+set_global_assignment -name MISC_FILE [file join $::quartus(qip_path) "pll_pre.cmp"]
+set_global_assignment -name MISC_FILE [file join $::quartus(qip_path) "pll_pre.ppf"]
